	include 'i/custom.i'
	include 'i/cia.i'
	include 'i/ciabits.i'
	include 'i/intbits.i'
	include 'i/dmabits.i'
	include 'i/bplconbits.i'
	
; OS Libraries and Constants
	include 'exec/types.i'
	include 'exec/exec.i'				; Include these because we use the exec lib
	include 'exec/exec_lib.i'
	include 'libraries/dos.i'			; Include these because we use the dos lib
	include 'libraries/dos_lib.i'
	include 'libraries/dosextens.i'
	include 'graphics/gfxbase.i'			; Include these because we use the dos lib
	include 'graphics/graphics_lib.i'
	
	;include agd/convtool.asm
	
; Our Functions and Constants
	include macros.asm				; Support Macros

	code
	
	include agd/handles.i				; Handle constants
	;include agd/tile.i				; Tile size constants
	include agd/loader.i				; Loader constants

	include agd/ptplayer.s				; ProTracker
	include sprites/tornado.asm			; Tornado Handlers
	include sprites/spanner.asm			; Spanner Handlers
	include sprites/points.asm			; 100/150 points handlers
	include sprites/cone.asm			; Cone Handler
	include sprites/bollard.asm			; Bollard Handler
	include sprites/vertwall.asm			; Vertical Wall handler
	include sprites/horiwall.asm			; Horizontal Wall handler
	include sprites/barrier.asm			; Barrier handler
	include sprites/explode.asm			; Car explosion handler
	include sprites/chopper.asm			; Chopper sprite handler
	include sprites/smoke.asm			; Smoke sprite handler
	include sprites/water.asm			; Water sprite handler
	include sprites/oil.asm				; Oil sprite handler
	include sprites/mud.asm				; Mud sprite handler
	include sprites/laps.asm			; Laps Handlers	
	include sprites/nitro.asm			; Nitro Handler
	include sprites/bomb.asm			; Bomb Handler
	
	include agd/interupt.asm			; Interupts
	include agd/unpack.s				; RNC Unpacker code	
	;include ocean_loader.asm			; Ocean Loader from Ross.
	include cars.i					; Cars constants	
	include terrain.i				; Terrain defs
	include tracks/track.i				; Track defs
	include audio.asm				; Audio Helper
	include sprites/game_sprite.asm			; Game Bob Engines
	include agd/input.asm				; Input handler
	include agd/copper.asm				; Copper Builder
	include agd/loader.asm				; Add in loader functions
	include agd/debug.asm				; Debug Helper
	include agd/handle.asm				; Data structure handler
	include scenes/winningcars.asm			; Winning Cars Scene
	include scenes/preparerace.asm			; Prepare to race scene
	include scenes/title.asm			; Title Screen
	include scenes/trackselect.asm			; Track Select Screen
	include scenes/upgrades.asm			; Upgrades
	include scenes/hiscores.asm			; Hi Scores scene
	include scenes/credits.asm			; Credits scene
	include scenes/race.asm				; InGame Racing
	include cars.asm				; Players Controls
	include agd/screen.asm				; Screen helper	
	include agd/text.asm				; Onscreen text
	include agd/sprite.asm				; Sprite helper
	include agd/bitmap.asm				; Bitmaps helper
	include agd/palette.asm				; Palette helper
	include panels.asm				; Onscreen panels
	include agd/score.asm				; Score helper
	include assets.asm				; Load assets functions	
	include cd32.asm				; CD32 Helper files